﻿// BS"D
// Equalize Border and Shading Options
// An InDesign 2018 script
// Copyright 2018 by Id-Extras.com (Bookraft LLC)
// Released under a GNU license (version 3), available here <https://www.gnu.org/licenses/>

var main = function(v,	i, n){
	var o = ["paragraphBorderBottomLeftCornerOption",
		"paragraphBorderBottomLeftCornerRadius",
		"paragraphBorderBottomLineWeight",
		"paragraphBorderBottomOffset",
		"paragraphBorderBottomOrigin",
		"paragraphBorderBottomRightCornerOption",
		"paragraphBorderBottomRightCornerRadius",
		"paragraphBorderColor",
		"paragraphBorderDisplayIfSplits",
		"paragraphBorderGapColor",
		"paragraphBorderGapOverprint",
		"paragraphBorderGapTint",
		"paragraphBorderLeftLineWeight",
		"paragraphBorderLeftOffset",
		"paragraphBorderOn",
		"paragraphBorderOverprint",
		"paragraphBorderRightLineWeight",
		"paragraphBorderRightOffset",
		"paragraphBorderStrokeEndCap",
		"paragraphBorderStrokeEndJoin",
		"paragraphBorderTint",
		"paragraphBorderTopLeftCornerOption",
		"paragraphBorderTopLeftCornerRadius",
		"paragraphBorderTopLineWeight",
		"paragraphBorderTopOffset",
		"paragraphBorderTopOrigin",
		"paragraphBorderTopRightCornerOption",
		"paragraphBorderTopRightCornerRadius",
		"paragraphBorderType",
		"paragraphBorderWidth"
	];
	for (i = 0; i < o.length; i++){
		if (p.hasOwnProperty(n = o[i].replace(/Border/, "Shading"))){
			if (v == 20) p[o[i]] = p[n];
			else p[n] = p[o[i]];
		}
	}
}

var e, p, w;
try{
	p = app.selection[0].paragraphs[0].appliedParagraphStyle;
}
catch(e){
	alert("Please select some text and try again...", "Equalize Border and Shading");
	exit();
}

var w = new Window("dialog", "Equalize Border and Shading Options");
with (w){
	add("staticText", undefined, "Style: " + p.name);
	w.b1 = add("button", undefined, "Use border properties");
	w.b2 = add("button", undefined, "Use shading properties");
	w.cancelButton = add("button", undefined, "Cancel");
	w.b1.characters = w.b2.characters = w.cancelButton.characters = 20;
}
w.b1.onClick = function(){w.close(10)}
w.b2.onClick = function(){w.close(20)}
w = w.show();
if (w == 2) exit();
app.doScript("main(w)", undefined, undefined, UndoModes.ENTIRE_SCRIPT, "Equalize Border and Shading Options");

